/* ֵˡ -- calc */

%{
#define YYSTYPE double
#include <math.h>
#include "calc.h"

const char* yyinStr;
double yyoutNum;

%}

/* BISON */
%token NUM
%left '-' '+'
%left '*' '/'
%left NEG     /* negation--ñޥʥ */
%right '^'    /* ٤ؿ        */

/* ʸˡ§³ */
%%
input:    /* ʸ */
        | input line
;

line:     '\n'
        | exp '\n'  { yyoutNum = $1; return 0; }
;

exp:      NUM                { $$ = $1;         }
        | exp '+' exp        { $$ = $1 + $3;    }
        | exp '-' exp        { $$ = $1 - $3;    }
        | exp '*' exp        { $$ = $1 * $3;    }
        | exp '/' exp        { $$ = $1 / $3;    }
        | '-' exp  %prec NEG { $$ = -$2;        }
        | exp '^' exp        { $$ = pow ($1, $3); }
        | '(' exp ')'        { $$ = $2;         }
;
%%


/**
 * ϴϡͤɤСdoubleͤ򥹥åѤ
 * ȡNUMפ֤ͰʳɤСʸΥ֤
 * ȥ֤ɤФ롣ե뤬0֤
 */

#include <ctype.h>
#include <stdio.h>

int yylex ()
{
  int c;

  /* ɤФ  */
  while ((c = *(yyinStr++)) == ' ' || c == '\t')
    ;
  /* ͤ   */
  if (c == '.' || isdigit (c))
    {
      yyinStr--;
      sscanf (yyinStr, "%lf", &yylval);
      while ((c = *(++yyinStr)) == '.' || isdigit(c)) {}
      return NUM;
    }
  /* եν  */
  if (c == '\0')         
    return 0;
  /* 1ʸ֤ */
  return c;             
}

int yyerror(char* s) {
  printf("yyerror: %s\n", s);
  return 0;
}

double calc(const char* str) {
  yyinStr = str;
  yyparse();
  return yyoutNum;
}

