#ifndef BOHA_CHARCOLOR
#define BOHA_CHARCOLOR

#include "util.h"

/// פǤǤȹ
/**
 * EMPTYϥץ쥤䡼Τ
 */
typedef enum {WHITE = 0, BLACK, EMPTY} CharColor_;

class CharColor {
public:
	CharColor(CharColor_ col) : col_(col) {}
	operator CharColor_() { return col_; }

	bool operator == (CharColor rhs) { return col_ == rhs.col_; }
	bool operator != (CharColor rhs) { return col_ != rhs.col_; }
	bool operator == (CharColor_ rhs) { return col_ == rhs; }
	bool operator != (CharColor_ rhs) { return col_ != rhs; }

public:
	CharColor reverse() {
		if (col_ == WHITE) return BLACK;
		else return WHITE;
	}
	Color color() const {
		if (col_ == WHITE) return Color::WHITE;
		else if (col_ == BLACK) return Color::BLACK;
		else return Color::GRAY;
	}
	Color color2() const {
		if (col_ == WHITE) return Color::BLUE;
		else if (col_ == BLACK) return Color::RED;
		else return Color::YELLOW;
	}

private:
	CharColor_ col_;
};

#endif // ! BOHA_CHARCOLOR
