#ifndef BOHA_SHOT
#define BOHA_SHOT

#include "char.h"

class Window;
class Player;
class Enemy;
class Shot;

class Shot : public Charactor {
public:
    Shot (const Point& pnt, const Point& spd,
		  CharColor col, bool isLaser, int width, const Point& srcspd);

    virtual void hit (Charactor* bc) { bc->hitByShot(this); }
    virtual void hitByPlayer (Player* bc);
    virtual void hitByEnemy (Enemy* bc);
    virtual void hitByShot (Shot* bc);

    bool isLeft() const { return spd_.x < 0; }

	virtual bool isLaser() const { return isLaser_; }

	virtual void moveGraphic() const;

	virtual void setPnt(const Point& pnt);

private:
	bool isLaser_;
	Point gspd_;

};

#endif // ! BOHA_SHOT

