/// Ȥ߹ߴؿҤüؿ֥Ȳ

#ifndef __BUILTINFUNCS_H__
#define __BUILTINFUNCS_H__

#include <functional>

template <class _New>
class New {
public:
    _New* operator () () {
	return new _New;
    }
};

/// NewCopy
/**
 * NewCopy ƥץ졼ȰȤơ
 * 󥹥ȥ饯ΰȤ롣
 * ƥץ졼Ȱݥ󥿤λ
 * *from Ȥäƥ󥹥ȥ饯ƤӽФ
 * ޤ VC ʤɤΥƥץ졼̥С
 * ݡȤƤʤѥǤϡ
 * NewCopyPtr ܤ̤
 */
template <class _New, class _From>
class NewCopy : public std::unary_function<_From, _New*> {
public:
    _New* operator () (const _From& from) {
	return new _New(from);
    }
};

// VC ʤɥƥץ졼̥С򥵥ݡȤƤʤ
// ѥưޤ
#ifndef __DONT_HAVE_TEMP_CLASS_SPEC__
template <class _New, class _From>
class NewCopy<_New, _From*> :
    public std::unary_function<_From*, _New*> {
public:
    _New* operator () (const _From* from) {
	return new _New(*from);
    }
};
#else
template <class _New, class _From =_New*>
class NewCopyFromPtr :
    public std::unary_function<_From, _New*> {
public:
    _New* operator () (const _From from) {
	return new _New(*from);
    }
};
#endif // ! __TEMP_CLASS_SPEC__

template <class _Target>
class Delete : public std::unary_function<_Target, void> {
public:
    void operator () (_Target*& target) {
	delete target;
	target = 0;
    }
};

template <class _Casted, class _From>
class DynamicCast : public std::unary_function<_From, _Casted> {
public:
    _Casted operator () (_From from) {
	return dynamic_cast<_Casted>(from);
    }
};

template <class _Casted, class _From>
class StaticCast : public std::unary_function<_From, _Casted> {
public:
    _Casted operator () (_From from) {
	return static_cast<_Casted>(from);
    }
};

template <class _Casted, class _From>
class ReinterpretCast : public std::unary_function<_From, _Casted> {
public:
    _Casted operator () (_From from) {
	return reinterpret_cast<_Casted>(from);
    }
};

template <class _Casted, class _From>
class ConstCast : public std::unary_function<_From, _Casted> {
public:
    _Casted operator () (_From from) {
	return const_cast<_Casted>(from);
    }
};

#include <algorithm>

/// STL ѥʥƥʤƤƲˤ
template <class _Container>
void deleteClear(_Container& cont) {
    for (typename _Container::iterator ite = cont.begin();
	 ite != cont.end(); ite++) {
	delete *ite;
    }
    cont.clear();
}

/// ؿ֥
template <class _Container>
class DeleteClear : public std::unary_function<_Container, void> {
public:
    void operator () (_Container& cont) {
	deleteClear(cont);
    }
};

#endif // ! __BUILTINFUNCS_H__
