/// BulletML Υѡĥ꡼
/**
 * c++  RELAX ̵äΤǤޤʬǺ뤳Ȥ
 */

#ifndef BOHA_BULLETML
#define BOHA_BULLETML

#include "util.h"
#include "xmltree.h"
#include "config.h"

#include <memory>
#include <string>
#include <fstream>
#include <map>
#include <utility>
#include <vector>
#include <cassert>

class EnemyCommand;

class BulletML {
protected:
    typedef std::vector<std::string> MyAttributes;
    typedef MyAttributes::const_iterator MyAttributeIte;

public:
    BulletML();
    virtual ~BulletML();

public:
    virtual void Parse() =0;

public:
    /**
     * BulletML ϻ;ĥ꡼¤κäɬפϤʤ
     * ٥뤫餳Τ߼ɤ
     */
    //@{
    XMLNode* getBulletRef(const std::string& key);
    XMLNode* getActionRef(const std::string& key);
    XMLNode* getFireRef(const std::string& key);
    bool haveActionRef(const std::string& key);
    //@}

    bool isHorizontal() const { return isHorizontal_; }

protected:
    XMLNode* addContent(const std::string& name);
    void addAttribute(const MyAttributes& attr, XMLNode* elem);
    void checkNode(XMLNode* elem);

protected:
    /// gccΥС֤θߴΤʤΤ
    template <class Char_>
    std::string uc2string(Char_* src, size_t len = std::string::npos);

protected:
    XMLNode* bulletml_;

    typedef std::map<std::string, XMLNode*> BulletMap;
    typedef std::map<std::string, XMLNode*> ActionMap;
    typedef std::map<std::string, XMLNode*> FireMap;
    BulletMap bulletMap_;
    ActionMap actionMap_;
    FireMap fireMap_;

    bool isHorizontal_;

};

template <class Char_>
std::string BulletML::uc2string(Char_* src, size_t len) {
    std::string dst;
    size_t i = 0;
    while (i != len && *src != '\0') {
		dst += *src;
		src++;
		i++;
    }
    return dst;
}

#endif // ! BOHA_BULLETML
