#ifndef BOHA_SELECT
#define BOHA_SELECT

#include "player.h"
#include "charcolor.h"
#include "mysdl_padinput.h"

class Select {
public:
	explicit Select(MSDL::Input* input);

	int selectBullet();

public:
	const std::string& bulletDir() const { return bulletDir_; }

private:
	static const int charWidth_ =8;
	static const int charHeight_ =20;
	void putString(const std::string& str, int x, int y, const Color& col);

private:
	MainWindow* win_;
	MSDL::Input* input_;

private:
	std::string bulletDir_;

};

#endif // ! BOHA_SELECT
